<template>
    <backend>

        <!-- profile completion modal -->
        <div class="modal fade" id="modal-form" tabindex="0" role="dialog" aria-labelledby="modal-form"
             aria-hidden="true">
            <div class="modal-dialog modal- modal-dialog-centered modal-sm" role="document">
                <div class="modal-content">
                    <div class="modal-body p-0">
                        <div class="card bg-secondary shadow border-0">
                            <div class="card-header bg-white">
                                <div class="text-muted text-center mb-3">Complete your Profile</div>
                            </div>
                            <div class="card-body px-lg-5 py-lg-5">
                                <form role="form">
                                    <!-- input: name -->
                                    <div class="form-group"
                                         :class="{'has-danger': !completeProfileForm.name.valid || $v.completeProfileForm.name.$error}">
                                        <div class="input-group input-group-alternative mb-3">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><font-awesome-icon
                                                        :icon="['fas', 'user']"
                                                        style="cursor: pointer; font-size: 22px;"/></span>
                                            </div>
                                            <input class="form-control"
                                                   :class="{'is-invalid': !completeProfileForm.name.valid || $v.completeProfileForm.name.$error}"
                                                   v-model.trim="$v.completeProfileForm.name.val.$model" name="name"
                                                   placeholder="Name" type="text">
                                        </div>
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!$v.completeProfileForm.name.val.required && $v.completeProfileForm.name.$error"
                                             role="alert">
                                            <span class="alert-inner--text">Field is required</span>
                                        </div>
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!completeProfileForm.name.valid" role="alert">
                                            <span class="alert-inner--text">{{ completeProfileForm.name.msg }}</span>
                                        </div>
                                    </div>

                                    <!-- input: profession -->
                                    <div class="form-group mb-3"
                                         :class="{'has-danger': !completeProfileForm.profession.valid || $v.completeProfileForm.profession.$error}">
                                        <div class="input-group input-group-alternative mb-3">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><font-awesome-icon
                                                        :icon="['fas', 'user-tie']"
                                                        style="cursor: pointer; font-size: 22px;"/></span>
                                            </div>
                                            <input class="form-control"
                                                   :class="{'is-invalid': !completeProfileForm.profession.valid || $v.completeProfileForm.profession.$error}"
                                                   v-model.trim="$v.completeProfileForm.profession.val.$model"
                                                   placeholder="profession" type="text">
                                        </div>

                                        <!-- validation msgs -->
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!$v.completeProfileForm.profession.val.required && $v.completeProfileForm.profession.$error"
                                             role="alert">
                                            <span class="alert-inner--text">Field is required</span>
                                        </div>
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!completeProfileForm.profession.valid" role="alert">
                                            <span class="alert-inner--text">{{ completeProfileForm.profession.msg }}</span>
                                        </div>
                                    </div>

                                    <!-- input: description -->
                                    <div class="form-group mb-3"
                                         :class="{'has-danger': !completeProfileForm.description.valid || $v.completeProfileForm.description.$error}">
                                        <div class="input-group input-group-alternative mb-3">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><font-awesome-icon
                                                        :icon="['fas', 'align-left']"
                                                        style="cursor: pointer; font-size: 22px;"/></span>
                                            </div>
                                            <input class="form-control"
                                                   :class="{'is-invalid': !completeProfileForm.description.valid || $v.completeProfileForm.description.$error}"
                                                   v-model.trim="$v.completeProfileForm.description.val.$model"
                                                   placeholder="description" type="text">
                                        </div>

                                        <!-- validation msgs -->
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!$v.completeProfileForm.description.val.required && $v.completeProfileForm.description.$error"
                                             role="alert">
                                            <span class="alert-inner--text">Field is required</span>
                                        </div>
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!completeProfileForm.description.valid" role="alert">
                                            <span class="alert-inner--text">{{ completeProfileForm.description.msg }}</span>
                                        </div>
                                    </div>

                                    <!-- input: city -->
                                    <div class="form-group mb-3"
                                         :class="{'has-danger': !completeProfileForm.city.valid || $v.completeProfileForm.city.$error}">
                                        <div class="input-group input-group-alternative mb-3">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><font-awesome-icon
                                                        :icon="['fas', 'city']"
                                                        style="cursor: pointer; font-size: 22px;"/></span>
                                            </div>
                                            <input class="form-control"
                                                   :class="{'is-invalid': !completeProfileForm.city.valid || $v.completeProfileForm.city.$error}"
                                                   v-model.trim="$v.completeProfileForm.city.val.$model"
                                                   placeholder="city" type="text">
                                        </div>
                                        <!-- validation msgs -->
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!$v.completeProfileForm.city.val.required && $v.completeProfileForm.city.$error"
                                             role="alert">
                                            <span class="alert-inner--text">Field is required</span>
                                        </div>
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!completeProfileForm.city.valid" role="alert">
                                            <span class="alert-inner--text">{{ completeProfileForm.city.msg }}</span>
                                        </div>
                                    </div>

                                    <!-- submit -->
                                    <div class="text-center">
                                        <button v-if="!completeProfileForm.loading" @click.prevent="complete"
                                                type="button" class="btn btn-primary my-4">Complete
                                        </button>
                                        <spring-spinner
                                                v-else
                                                :animation-duration="1500"
                                                :size="64"
                                                color="#5e72e4"
                                                style="width: 100%"
                                        />
                                    </div>
                                </form>
                            </div>
                        </div>


                    </div>

                </div>
            </div>
        </div>
        <!-- endmodal -->

        <div v-if="profileCompletion" class="text-center mt-4 mb-4">
            <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#modal-form">
                Complete your Profile first
            </button>
        </div>

        <main v-else class="profile-page">
            <section class="section-profile-cover section-shaped">
                <!-- Circles background -->
                <div class="shape shape-style-1 shape-primary alpha-4">
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                </div>
                <!-- SVG separator -->
                <div class="separator separator-bottom separator-skew">
                    <svg x="0" y="0" viewBox="0 0 2560 100" preserveAspectRatio="none" version="1.1"
                         xmlns="http://www.w3.org/2000/svg">
                        <polygon class="fill-white" points="2560 0 2560 100 0 100"></polygon>
                    </svg>
                </div>
            </section>
            <section class="section">
                <div class="container">
                    Update
                    <div class="card card-profile shadow mt--400">
                        <div class="px-4">
                            <div class="row justify-content-center">
                                <div class="col-lg-3 order-lg-2">
                                    <div class="card-profile-image">
                                        <a href="#">
                                            <img src="~assets/img/theme/team-4-800x800.jpg" class="rounded-circle"
                                                 alt="image">
                                        </a>
                                    </div>
                                </div>
                                <div class="col-lg-4 order-lg-3 text-lg-right align-self-lg-center">
                                    <div class="card-profile-actions py-4 mt-lg-0">
                                        <a href="#" class="btn btn-sm btn-info mr-4">Connect</a>
                                        <a href="#" class="btn btn-sm btn-default float-right">Message</a>
                                    </div>
                                </div>
                                <div class="col-lg-4 order-lg-1">

                                </div>
                            </div>
                            <div class="text-center mt-5">
                                <h3>{{ $auth.user.name }}<span class="font-weight-light"></span></h3>
                                <div class="h6 font-weight-300"><i class="ni location_pin mr-2"></i>{{ $auth.user.city
                                    }}
                                </div>
                            </div>
                            <div class="mt-5 py-5 border-top text-center">
                                <div class="row justify-content-center">
                                    <div class="col-lg-9">
                                        {{ $auth.user.description }}
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </section>
        </main>
    </backend>
</template>
<style lang="css">
    @media (max-width: 991.98px)
        .section-profile-cover {
            height: 200px;
        }

        .section-profile-cover {
            height: 200px;
        }
</style>
<script>
    import backend from '~/components/layouts/backend.vue'
    import {required} from 'vuelidate/lib/validators'
    import {SpringSpinner} from 'epic-spinners'
    import Vue from 'vue'

    export default {
        auth: 'auth',
        data() {
            return {
                completeProfileForm: {
                    loading: false,
                    name: {
                        val: '',
                        msg: '',
                        valid: true
                    },
                    profession: {
                        val: '',
                        msg: '',
                        valid: true
                    },
                    description: {
                        val: '',
                        msg: '',
                        valid: true
                    },
                    city: {
                        val: '',
                        msg: '',
                        valid: true
                    },
                    success: false,
                    sent: false
                }
            }
        },
        components: {
            backend,
            SpringSpinner
        },
        validations: {
            completeProfileForm: {
                name: {
                    val: {
                        required
                    }
                },
                profession: {
                    val: {
                        required
                    }
                },
                description: {
                    val: {
                        required
                    }
                },
                city: {
                    val: {
                        required
                    }
                },
            }
        },
        mounted() {
            if (typeof this.$auth.user.name === 'undefined') {
                $("#modal-form").modal()
            }
        },
        computed: {
            profileCompletion() {
                return typeof this.$auth.user.name === 'undefined'
            }
        },
        methods: {
            async complete() {
                // call local validation
                this.$v.completeProfileForm.$touch();
                if (this.$v.completeProfileForm.$pending || this.$v.completeProfileForm.$error) return;

                let completeProfileForm = this.completeProfileForm
                // send update request
                this.$axios.put(process.env.BACKEND_API + '/user/lawyer/profile', {
                    "name": completeProfileForm.name.val,
                    "profession": completeProfileForm.profession.val,
                    "description": completeProfileForm.description.val,
                    "city": completeProfileForm.city.val,
                }).then(results => {
                    completeProfileForm.name.valid = true
                    completeProfileForm.profession.valid = true
                    completeProfileForm.description.valid = true
                    completeProfileForm.city.valid = true
                    completeProfileForm.success = true;
                    completeProfileForm.sent = true;
                    completeProfileForm.loading = false
                    Vue.notify({
                        group: 'foo',
                        type: 'success',
                        title: 'Sign up',
                        text: 'Successfully completed profile!'
                    })
                    $('#modal-form').modal('hide')
                    this.$auth.fetchUser()
                }).catch(error => {
                    console.log(error);
                    completeProfileForm.loading = false;
                    completeProfileForm.success = false;
                    completeProfileForm.sent = true;
                    Vue.notify({
                        group: 'foo',
                        type: 'error',
                        title: 'Error',
                        text: typeof error.response.data == 'string' ? error.response.data : 'Something went wrong!'
                    })
                    let errors = error.response.data.errors
                    if ("name" in errors) {
                        completeProfileForm.name.valid = false
                        completeProfileForm.name.msg = errors.name.message
                    }
                    if ("profession" in errors) {
                        completeProfileForm.profession.valid = false
                        completeProfileForm.profession.msg = errors.profession.message
                    }
                    if ("description" in errors) {
                        completeProfileForm.description.valid = false
                        completeProfileForm.description.msg = errors.description.message
                    }
                    if ("city" in errors) {
                        completeProfileForm.city.valid = false
                        completeProfileForm.city.msg = errors.city.message
                    }
                });
            }
        }
    }
</script>